<?php
/*
 *      Copyright 2007 by Dag Erlandsson (langarod@gmail.com)
 *      This software is distributed under the GNU public license version 2
*/
  include("config.inc");

  $delay = (int)$_GET['delay'];
  if($delay < 10 || $delay > 10000)
    $delay = 100;

  $frameStep = (int)$_GET['step'];
  if($frameStep < 1 || $frameStep > 10)
    $frameStep = 1;

  if(!is_dir($image_root))
  {
    echo "$image_root isn't a directory! Please check config.php\n";
  }

  $dh = opendir( $image_root );
  if($dh == FALSE)
  {
    echo "Unable to open directory $image_root\n";
  }
  else
    closedir($dh);
?>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
    <link rel="stylesheet" type="text/css" href="style.css">
    <script language="JavaScript" type="text/javascript">

      var delay = parseInt(<?php echo $delay; ?>);
      var frame=0;
      var frameStep = parseInt(<?php echo "$frameStep\n" ?>);
      var startTime = '00:00';
      var playState = 0;
      var liveView = false;
      var currentFeed = '';

      // This urls and ports to motion is translated in the apache proxy module
      var feedProperties = [
<?php
      printFeedsProperties();
?>
	];

      function onNewFrame()
      {
        if(playState == 0) // Stop
	{
	}
	else if(playState == 2) // Play
        {
          frame+=frameStep;
        }
	else if(playState == -2) // back Play
        {
          frame-=frameStep;
        }
        else if(playState == 1) // Step
        {
          frame+=frameStep;
          playState = 0;
        }
        else if(playState == -1) // back Step
        {
          frame-=frameStep;
          playState = 0;
        }

        document.getElementById('textFrame').value = frame;
      }

      function playbackAction(action)
      {
	fd = document.getElementById('txtFeedDate');
	feedDate = fd.options[fd.selectedIndex].value;

        imgUrl = 'h.php?delay=' + delay + '&feed=' + currentFeed + '&date=' + feedDate;
        if(frameStep!= 1)
          imgUrl += '&step=' + frameStep;

        if(startTime != '')
        {
          imgUrl += '&time=' + startTime;
        }

        img = document.getElementById('image1');
        if(action == 'live')
        {
          liveView = true;
          playState = 0;
<?php
          if($mode == 'browser')
            echo "img.src=liveFeedUrl(currentFeed);";
          else
            echo " img.setCurrentURL(liveFeedUrl(currentFeed));";
?>
        }
        else
        {
          liveView = false;
          if(action == 'stop')
          {
            playState = 0;
<?php  
            if($mode == 'browser')
              echo "img.src = imgUrl + '&frame=' + frame;";
            else
              echo "img.setCurrentURL(imgUrl + '&frame=' + frame + '&command=singleStream');";
?>
          }
          if(action == 'play')
          {
            playState = 2;
<?php
            if($mode == 'browser')
              echo "img.src = imgUrl + '&command=fplay&frame=' + (frame + frameStep);";
            else
              echo "img.setCurrentURL(imgUrl + '&command=fplay&frame=' + (frame + frameStep));";
?>
          }
          if(action == 'bplay')
          {
            playState = -2;
<?php
            if($mode == 'browser')
              echo "img.src = imgUrl + '&command=bplay&frame=' + (frame - frameStep);";
            else
              echo "img.setCurrentURL(imgUrl + '&command=bplay&frame=' + (frame - frameStep));";
?>
          }
          if(action == 'bstep')
          {
            playState = -1;
<?php
            if($mode == 'browser')
              echo "img.src = imgUrl + '&frame=' + (frame - frameStep);";
            else
              echo "img.setCurrentURL(imgUrl + '&frame=' + (frame - frameStep) + '&command=singleStream');";
?>
          }
          if(action == 'step')
          {
            playState = 1;
<?php
            if($mode == 'browser')
              echo "img.src = imgUrl + '&frame=' + (frame + frameStep);";
            else
              echo "img.setCurrentURL(imgUrl + '&frame=' + (frame + frameStep) + '&command=singleStream');";
?>
          }
          if(action == 'first')
          {
            playState = 0;
            frame = 0;
<?php
            if($mode == 'browser')
              echo "img.src = imgUrl + '&frame=' + frame;";
            else
              echo "img.setCurrentURL(imgUrl + '&frame=' + frame + '&command=singleStream');";
?>
          }
        }
      }

      function setFrame(newFrame, force) // see force as a default parameter with false
      {          
        newFrame = parseInt(newFrame);
        if(frame != newFrame || force!=null)
        {
          frame = newFrame;
          if(liveView)
            playbackAction('live');
          else
            playbackAction('stop');
        }
      }

      var feeds = new Array();
<?php
        $feednames = array();
        $dh = opendir( $image_root );
        while( $file = readdir( $dh ) )
        {
          if($file == '.' | $file == '..')
            continue;
          if(is_dir("$image_root/$file") )
            $feednames[] = $file;
        }
        sort($feednames);

        foreach($feednames as $key => $feedName)
        {
          echo "feeds[$key] = ['$feedName'";

          $feedDates = array();
          $dh = opendir( "$image_root/$feedName" );
          while( $file = readdir( $dh ) )
          {
            if($file == '.' | $file == '..')
              continue;
            if(is_dir("$image_root/$feedName/$file") )
              $feedDates[] = $file;
          }
          sort($feedDates);
         
          foreach($feedDates as $key => $feedDate)
          {
            echo ",'$feedDate'";
          }
          echo "];\n";
        }
?>

      function printFeeds()
      {
        for(i=0; i<feeds.length; i++)
        {
          document.write("<tr>");
          document.write("  <td id='" + feeds[i][0] + "' class='feedUnSelect' onClick=\"enterFeed('" + feeds[i][0] + "')\">");

          var found = false;
          for(fi = 0; fi < feedProperties.length; fi++)
          {
            if(feedProperties[fi][0] == feeds[i][0])
            {
              document.write(feedProperties[fi][1]);
              found = true;
              break;
            }
          }
          if(!found)
            document.write("  <p>" + feeds[i][0] + "</p>");
          document.write("</tr>");
        }
      }

      function printDateDropdown(feedName)
      {
        dl = document.getElementById('txtFeedDate');
        oldFeedDate = dl.options[dl.selectedIndex].value;

        for(i = dl.options.length-1; i>=0; i--)
          dl.options[i] = null;

        selected = false;
        for(fi = 0; fi < feeds.length; fi++)
        {
          if(feeds[fi][0] == feedName)
          {
            for(di = 1; di < feeds[fi].length; di++)
            {
              dl.options[di-1] = new Option(feeds[fi][di]);
              dl.options[di-1].value = feeds[fi][di];
              if(feeds[fi][di] == oldFeedDate)
              {
                dl.options[di-1].selected = true;
                selected = true;
              }
            }
            if(selected == false)
              dl.options[dl.options.length-1].selected=true; // select last item in list
          }
        }
      }

      function dateClick()
      {
        setFrame(0, true);
        updateTimeline();
      }

      function updateTimeline()
      {
        if(currentFeed != '')
          timeUrl = 'timeline.php?feed=' + currentFeed + '&date=' + feedDate;
        else
          timeUrl = 'timeline.php';
        document.getElementById('timeline').src = timeUrl;
      }

      function enterFeed(feedName)
      {
        if(currentFeed != '')
          feedUnSelect(currentFeed);
        feedSelect(feedName);

        currentFeed = feedName;

        printDateDropdown(feedName);
        setFrame(0, true)
        updateTimeline();
      }

      function feedSelect(feedName)
      {
        td = document.getElementById(feedName);
        td.className = 'feedSelect';
      }
      function feedUnSelect(feedName)
      {
        td = document.getElementById(feedName);
        td.className = 'feedUnSelect';
      }

      function onKeyPressOnlyNumber(e)
      {
        if(e && e.which)
          c = e.which;
        else
          c = e.keyCode;

        if( c == 13 || c == 8 || c == 37 || c == 39 || c == 35 || c == 36 || c == 46 || c ==9) // delete, home, end etc.
          return true;
        if(c < 48 || c > 57)
          return false;
        return true;
      }
      function stopOnKeyEnter(e)
      {
        if(e && e.which)
          c = e.which;
        else
	  c = e.keyCode;

        if(c == 13)
          playbackAction('stop');
      }

      function liveFeedUrl(feedName)
      {
        for(fi = 0; fi < feedProperties.length; fi++)
        {
          if(feedProperties[fi][0] == feedName)
          {
            playState == 0;
            return feedProperties[fi][2];
          }
        }      
      }

      function configFeedUrl(feedName)
      {
        for(fi = 0; fi < feedProperties.length; fi++)
        {
          if(feeds[fi][0] == feedName)
          {
            playState == 0;
            return feedProperties[fi][3];
          }
        }      
      }
     
      function setTime(newTime, force)
      {
        newTime = newTime.match(/[0-9]{2}:[0-9]{2}/);
	if((newTime != '' && newTime != startTime) || force == true)
        {
          startTime = newTime;
          document.getElementById('textTime').value = newTime;
          setFrame(0, true);
        }
      }

      function tl_move(e)
      {
        if (document.layers) 
        {
          rx = e.pageX;
          rx = rx - document.getElementById('timeline').x;
        }
        else
        {
	  if (document.all) 
            rx = event.clientX + document.body.scrollLeft;
	  else
	    rx = e.clientX + document.body.scrollLeft;

          iPos = 0; elt = document.getElementById('timeline');
          while (elt != null)  
          {
            iPos += elt.offsetLeft;
            elt = elt.offsetParent;
          }
        }
        rx = rx - iPos;
        mins=parseInt(rx * (1440/(document.getElementById('timeline').width-2)));
        if (mins < 0) { mins = 0; }
        if (mins > 1439) { mins = 1439; }

        hrs=parseInt(mins / 60);
        mins%=60;

        if(hrs < 10)
          hrs = '0' + hrs;
        if(mins < 10)
          mins = '0' + mins;
        document.getElementById('textTime').value = hrs + ':' + mins;
    
        return false;
      }
      function tl_out()
      {
        document.getElementById('textTime').value = startTime;
      }

      function tl_click()
      {
        time = document.getElementById('textTime').value;
        setTime(time);
      }

    </script>
    <title>Historical viewer</title>
  </head>
  <body>
    <h1>Viewer</h1>

  <table border="1">
    <tr>
      <td>
<?php
        if($mode == 'browser') 
        {
          echo "<img src=images/nofeed.gif id='image1' onload='return onNewFrame();'>";
        }
        else
        {
          echo '<applet id="image1" name="image1" code=com.charliemouse.cambozola.Viewer archive=cambozola/dist/cambozola.jar width="384" height="288" style="border-width:0; border-color:gray; border-style:solid;" MAYSCRIPT>';
          echo '  <param name=url value="h.php">';
          echo '  <param name=onnewframe value="onNewFrame">';
          echo '  <param name=debug value=true>';
          echo '</applet>';
        }
?>
      </td>
      <td valign="top">
        <table border="1">
          <script language="JavaScript" type="text/javascript">
            printFeeds();
          </script>
        </table>
      </td>
      <td valign="bottom">
        <table>
          <tr>
            <td>
            </td>
            <td align="right">
            </td>
          </tr>
          <tr>
            <td colspan=2>
              <img src=timeline.php id='timeline' onMouseMove="return tl_move(event);" onMouseOut="return tl_out();" onClick="return tl_click();">
            </td>
          </tr>
          <tr>
            <td>
              <select id="txtFeedDate" name="txtFeedDate" onclick="dateClick();">
                <option>Empty</option>
              </select> 
              <input type="text" size="4" value="" id="textFrame" onchange="setFrame(this.value);" onKeyPress="return onKeyPressOnlyNumber(event);" onKeyup="stopOnKeyEnter(event);">
              <input type="text" size="4" value="00:00" id="textTime" onChange="setTime(this.value);" onKeyup="stopOnKeyEnter(event);">
            </td>
            <td align="right">
              <input type="button" value="live" onClick="playbackAction('live');">
            </td>
          </tr>
          <tr>
            <td>
              <table>
                <tr>
                  <td><img src="images/rewind.gif" width="24" height="24" onClick="playbackAction('first');" alt="|<" title="Rewind to start of day" style="cursor: pointer"></td>
                  <td width="6"></td>
                  <td><img src="images/stepback.gif" width="24" height="24" onClick="playbackAction('bstep');" alt="<|" title="Go back one frame" style="cursor: pointer"></td>
                  <td width="6"></td>
                  <td><img src="images/playback.gif" width="24" height="24" onClick="playbackAction('bplay');" alt="<" title="Play backwards" style="cursor: pointer"></td>
                  <td width="6"></td>

                  <td><img src="images/stop.gif" width="24" height="24" onClick="playbackAction('stop');" alt="||" title="Stop playing" style="cursor: pointer"></td>
                  <td width="6"></td>
                  <td><img src="images/playfrwd.gif" width="24" height="24" onClick="playbackAction('play');" alt=">" title="Play forwards" style="cursor: pointer"></td>
                  <td width="6"></td>
                  <td><img src="images/stepfrwd.gif" width="24" height="24" onClick="playbackAction('step');" alt="|>" title="Go forward one frame" style="cursor: pointer"></td>
<!--
                  <td width="6"></td>
                  <td><img src="images/playend.gif" width="24" height="24" onClick="playbackAction('last');" alt=">|" title="Go forward to end of day" style="cursor: pointer"></td>
-->
                </tr>
              </table>
            </td>
            <td align="right" valign="buttom">
              <input type="button" value="settings" onClick="window.open(configFeedUrl(currentFeed));">
            </td>
          </tr>
        </table>
      </td>
    <tr>
  </table>
  <br>
</body>
</html>
